<?php
/*******************************************************************************************
*   Script du module upload réalisé par Saïd tikijja pour le projet JBC Explorer           *
*   Site web du projet : http://jcjcjcjc.free.fr/                                          *
*   Forum du projet : http://www.freescript.be/viewforum.php?forum=10                      *
*   mail : sanid@free.fr                                                                   *
*                                                                                          *
*                          UPLOAD.CONF.PHP                                                 *
*   Fichier de configuration du script                                                     *
*                                                                                          *
*   Note : le module utilise aussi des paramètres de l'Explorer (config.inc.php)           *
*                                                                                          *
*******************************************************************************************/

/**
     * Paramètres à ajouter aux champ de type file (ex: balise style, évenements JS...)
     * Type : chaine
     * Valeur par défaut : 'class="form"'
     */
$FieldOptions = 'class="form"';

/**
     * Nombre de champs de type file que le script devra gérer.
     * En gros le nombre de fichiers pouvant être transmis en même temps !
     * Type : entier
     * Valeur par défaut : 5
     * N'abusez pas du nombre de champs surtout si vous activez le redimensionnement des images
     * J'ai testé l'envoi de 5 images jpeg sur free.fr
     * redimensionnement et envoi ok !
     */
$Fields = 5;

 /**
     * Définit si les champs sont obligatoires ou non.
     * Si le champ est laissé vide, un message l'indiquera mais le script continuera pour les autres fichiers
     * Type : booléen
     * Valeur par défaut : true
     */
$Required = true;

/**
     * Liste des extensions autorisées.
     * Les extensions doivent être séparées par des points virgules.
     * Type : chaine
     * Valeur par défaut : chaine vide (toute extension autorisée)
     * exemple si vous voulez limiter l'upload aux images mettez .jpg;.jpeg;.gif;.png';
     */
$Extension = '.gif;.png;.jpg;.jpeg';
/**
     * Liste des extensions à renommer
     * Les extensions doivent être séparées par des points virgules.
     * Type : chaine
     * Valeur par défaut : .php;.php3;php5;inc;htm;.html
     * exemple: si vous voulez autoriser l'envoi de fichier php et php3 mais ne souhaitez pas qu'ils conservent leur extension .php indiquez '.php;.php3';
     */

$Extension_renamed= '.php;.php4;.php3;.php5;.inc';

/**
     * Suffixe à ajouter aux extensions à renommer
     * Type : chaine
     * Valeur par défaut : xxx
     * Dans l'exemple précédent, si vous indiquez ici 'xxx' un fichier nommé script.php sera renommé en script.phpxxx
     */
$SuffExtension ='xxx';


/**
     * Répertoire de destination dans lequel vont être chargé les fichiers. Accepte les chemins relatifs et absolus
     * Type : chaine
     * Valeur par défaut : $link (=dossier ouvert par l'utilisateur)
     */

$DirUpload = $_SESSION['DirUpload'];


/**
     * Chaine de caractères représentant les entêtes de fichiers autorisés (mime-type).
     * Les entêtes doivent être séparées par des points virgules.
     * Type : chaine
     * Valeur par défaut : chaine vide (tout type d'entête autorisé)
     */

$MimeType = '';

 /**
     * Permet de préciser un nom pour le fichier à uploader. Peut s'utiliser conjointement avec les propriétés $Suffixe / $Prefixe
     * si vous avez autorisé l'envoi de plusieurs fichiers en même temps...
     * ..les fichiers suivants le premier seront préfixés avec [x] où x est le rang du fichier 
     * Type : chaine
     * Valeur par défaut : chaine vide
     */

$Filename = '';






/**
     * Préfixe pour un nom de fichier (chaine de caractère qui sera ajoutée au début de chaque nom de fichier)
     * Type : chaine
     * Valeur par défaut : chaine vide
     */
 
$Prefixe ='' ;

/**
     * Suffixe pour un nom de fichier (chaine de caractère qui sera ajoutée à la fin de chaque nom de fichier)
     * Type : chaine
     * Valeur par défaut : chaine vide
     */

$Suffixe = ''  ;

/**
     * Méthode à employer pour l'écriture des fichiers :
     *  0 : si un fichier de même nom est présent dans le répertoire, il est écrasé par le nouveau fichier
     *  1 : si un fichier de même nom est présent dans le répertoire, le nouveau fichier est uploadé mais précédé de la mention indiquée dans la variable $CopiePrefixe
     *  2 : si un fichier de même nom est présent dans le répertoire, le nouveau fichier est ignoré
     * Type : entier compris entre 0 et 2
     * Valeur par défaut : 1
     */
$WriteMode = 1 ;

/**
     * Préfixe pour un nom de fichier si ce nom existe déjà dans le répertoire
     * Utilisé si $WriteMode est initialisé à 1
     * Si vous laissez la chaine vide, le fichier sera  préfixé avec [x] où x est un entier incrémenté automatiquement
     * Type : chaine
     * Valeur par défaut : chaine vide
     */
$CopiePrefixe='';

/**
     * Débit de la connexion utilisateur, exprimée en kilobit, sur laquelle sera basée le calcul de la fonction set_time_limit
     * Type : valeur numérique
     * Valeur par défaut : 33.6
     * Le script peut modifier le time_limit de PHP mais chez free je ne crois pas que ça fonctionne alors j'ai viré
     * Si vous souahitez le remettre il faut décommenter la ligne ci dessous et décommenter la fonction SetTimelimit dans le fichier upload.func.inc
     */
# $Debit = 33.6;


/**
     * Politique de sécurité max : ignore tous les fichiers exécutables / interprétables.
     * Type : booléen
     * Valeur par défaut : false
     */
$SecurityMax = false ;

/**
     * Indique s'il faut vérifier la provenance du formulaire d'upload des fichiers. Si la chaine est vide, aucune vérification n'est effectuée.
     * Pour lancer la vérification, il faut indiquer l'URI du formulaire de soumission des données.
     * Type : chaine
     * Valeur par défaut : chaine vide

     */
$CheckReferer = '';

/**
     * Définit si les erreurs de configuration de la classe doivent être affichées en sortie écran et doivent stopper le script courant.
     * Type : booléen
     * Valeur par défaut : true

     */
$TrackError = true;

/**
     * Définit si les événements divers (extension modifiée, fichier déjà existant...) doivent être indiqués en sortie écrans lorque le transfert àa bien fonctionné.
     * Type : booléen
     * Valeur par défaut : true
     */
$TrackMessage = true;



/**
     * Taille maximum exprimée en kilo-octets pour l'upload d'un fichier.
     * Type : numérique
     * Valeur par défaut : celle configurée dans le php.ini
     */
     
$MaxFilesize = preg_replace('/M/', '', ini_get('upload_max_filesize')) * 1024;


/**
     * Largeur maximum d'une image exprimée en pixel.
     * Type : entier
     * Valeur par défaut : null (aucune vérification)
     */
$ImgMaxWidth = '50' ;

    /**
     * Hauteur maximum d'une image exprimée en pixel.
     * Type : entier
     * Valeur par défaut : null (aucune vérification)
     */
$ImgMaxHeight = '50' ;
    
    /**
     * Largeur minimum d'une image exprimée en pixel.
     * Type : entier
     * Valeur par défaut : null (aucune vérification)
     */
$ImgMinWidth =  '30';
    
    /**
     * Hauteur minimum d'une image exprimée en pixel.
     * Type : entier
     * Valeur par défaut : null (aucune vérification)
     */
$ImgMinHeight = '30' ;
/**
     * Définit si les images plus grandes que la taille autorisée doivent être redimensionnées.
     * GD2 doit être activé sur votre serveur
     * Type : booléen
     * Valeur par défaut : true

     */
$Resize = true;
 /**
     * Qualité des images JPG qui seront redimensionnées
     * Type : entier
     * Valeur par défaut : 75
     */
$QualityJPG = '75';
/**
     * nombre de caractères maximum pour les noms de dossier créés.
     * Type : entier
     * Valeur par défaut : 20
*/
$maxfolder ='20';
/**
     * Définit si il est possible de créer des dossiers
     * Type : booléen
     * Valeur par défaut : true
     */
$CreateDir=true;
/**
     *initialisation des tableaux de messages
     */
$ArrOfError = array();
$ArrOfMessage =array();
?>