<?php
/*******************************************************************************************
*   Script du module upload réalisé par Saïd Tikijja pour le projet JBC Explorer           *
*   Site web du projet : http://jcjcjcjc.free.fr/                                          *
*   Forum du projet : http://www.freescript.be/viewforum.php?forum=10                      *
*   mail : sanid@free.fr                                                                   *
*                                                                                          *
*                          UPLOAD.FUNC.PHP                                                 *
*                                                                                          *
*   Ce fichier contient toutes les fonctions nécessaires au script                         *
*                                                                                          *
*   Note : le module utilise aussi des fonctions de l'Explorer (functions.inc.php)         *
*                                                                                          *
*******************************************************************************************/

function thumbnail($imgfile)
{
global $img,$_ext;
$img["format"]=preg_replace("/.*\.(.*)$/","\\1",$_ext);
$img["format"]=strtoupper($img["format"]);
if ($img["format"]=="JPG") {
	$img["src"] = ImageCreateFromJPEG ($imgfile);
}
if ($img["format"]=="PNG") {
	$img["src"] = ImageCreateFromPNG ($imgfile);
}
if ($img["format"]=="GIF") {
	$img["src"] = ImageCreateFromGIF ($imgfile);
}
@$img["lebar"] = imagesx($img["src"]);
@$img["tinggi"] = imagesy($img["src"]);
}

// Creates a transparent image rather than the default black image
function imageCreateTransparent($x, $y) { 
    $imageOut = imagecreate($x, $y);
    $colourBlack = imagecolorallocate($imageOut, 0, 0, 0);
    imagecolortransparent($imageOut, $colourBlack);
    return $imageOut;
}

function size_auto($size)
    {
    global $img;
     
        if ($img["lebar"]>=$img["tinggi"]) {
            $img["lebar_thumb"]=$size;
            @$img["tinggi_thumb"] = ($img["lebar_thumb"]/$img["lebar"])*$img["tinggi"];
  
    
        } else {
    
            $img["tinggi_thumb"]=$size;
            @$img["lebar_thumb"] = ($img["tinggi_thumb"]/$img["tinggi"])*$img["lebar"];
  
        }
    }

function save_img($save="")
    {
    global $img,$QualityJPG;
  
        if (empty($save)) $save=strtolower("./thumb.".$img["format"]);
        /* changez ImageCreateTrueColor en ImageCreate si la version de GD installée ne supporte pas ImageCreateTrueColor function*/
        $img["des"] = imageCreateTransparent($img["lebar_thumb"],$img["tinggi_thumb"]);
            @imagecopyresized ($img["des"], $img["src"], 0, 0, 0, 0, $img["lebar_thumb"], $img["tinggi_thumb"], $img["lebar"], $img["tinggi"]);

        if ($img["format"]=="JPG" || $img["format"]=="JPEG") {
            //JPEG
            //default quality jpeg
            $img["quality"]=$QualityJPG;
            imageJPEG($img["des"],"$save",$img["quality"]);
   
        return true;
        } elseif ($img["format"]=="PNG") {
            //PNG
            imagePNG($img["des"],"$save");
        return true;
        } elseif ($img["format"]=="GIF") {
            //GIF
            imageGIF($img["des"],"$save");
        return true;
        } elseif ($img["format"]=="WBMP") {
            //WBMP
            imageWBMP($img["des"],"$save");
        return true;
        }
    }
 function resize($temp,$DirUpload,$new_filename)
 {
               global $ImgMaxWidth,$ImgMaxHeight,$userdata;
   
               thumbnail($temp);
               //on la retaille
               if ($ImgMaxHeight<=$ImgMaxWidth) {
               size_auto($ImgMaxWidth);
               } else {
               size_auto($ImgMaxHeight);
               }
               //on la copie ;-)
               if(save_img($DirUpload . $new_filename))
               {
      
               return true;
           }
}


function save_file($temp,$DirUpload,$new_filename){

               global $width,$height,$userdata;          
       
               if ($width || $height)
               {
                    if(resize($temp,$DirUpload,$new_filename))
                    return true;
                    else
                    return false;
               }
               else
               {
               if(move_uploaded_file($temp, $DirUpload . $new_filename))
                  {            
                  return true;
                  }
               }
               return false;
               }
   
    /**
     * Lance l'initialisation de la classe pour la génération du formulaire
     * @access public
     */
    function InitForm() {

        SetMaxFilesize();
        CreateFields();
    }

    /**
     * Retourne le tableau des erreurs survenues durant l'upload
     *
     * <code>
     * if ($UploadError) {
     *     print_r($Upload-> GetError);
     * }
     * </code>
     *
     * @access public
     * @param integer $num_field    numéro du champ 'file' sur lequel on souhaite récupérer l'erreur
     * @return array                tableau des erreurs
     */
    function GetError($num_field='') {
    global $ArrOfError ;
    //echo "geterror($num_field)";
        if (Empty($num_field)) return $ArrOfError;
        else                  return $ArrOfError[$num_field];
    }
    function GetMessage($num_field='') {
    global $ArrOfMessage ;
    //echo "geterror($num_field)";
        if (Empty($num_field)) return $ArrOfMessage;
        else                  return $ArrOfMessage[$num_field];
    }
    
    
    /**
     * Retourne le tableau contenant les informations sur les fichiers uploadés
     *
     * <code>
     * if (!$UploadError) {
     *     print_r($Upload-> GetSummary());
     * }
     * </code>
     *
     * @access public
     * @param integer $num_field    numéro du champ 'file' sur lequel on souhaite récupérer les informations
     * @return array                tableau des infos fichiers
     */
    function GetSummary($num_field='') {
    global $num_field,$Infos;
        if ($num_field == '') return $Infos;
        else                  return $Infos[$num_field];
    }
   
    /**
     * Lance les différents traitements nécessaires à l'upload
     * @access public
     */
    function Execute(){
   
        CheckConfig();
        VerifyReferer();
        //fonction settimelimit désactivée
       // SetTimeLimit();
        CheckUpload();
    }

    /**
     * Fonction lançant les vérifications sur les fichiers. Initialisation de la variable $UploadError à true si erreur, lance la 
     * fonction d'écriture si toutes les vérifications sont ok.
     * @access private
     */
    function CheckUpload() {
        global $UploadError,$ArrOfError,$_field,$UploadSuccess ,$_name,$_ext,$_pseudo;
          // Parcours des fichiers à uploader
        for ($i=0; $i < count($_FILES['userfile']['tmp_name']); $i++)  {
            
            // Récup des propriétés
            $_field = $i+1;                                // position du champ dans le formulaire à partir de 1 (0 étant réservé au champ max_file_size)
            $_size  = $_FILES['userfile']['size'][$i];     // poids du fichier
            $_type  = $_FILES['userfile']['type'][$i];     // type mime
            $_name  = $_FILES['userfile']['name'][$i];     // nom du fichier
            $_temp  = $_FILES['userfile']['tmp_name'][$i]; // emplacement temporaire
            $_ext   = strtolower(substr($_name, strrpos($_name, '.'))); // extension du fichier
            
            // On exécute les vérifications demandées
            if (is_uploaded_file($_FILES['userfile']['tmp_name'][$i])) {

               CheckSecurity($_type,$_ext);

                CheckMimeType($_type);
                CheckExtension($_ext);
                CheckImg($_temp);
                //echo ">>>>$_ext<<<<<<br>";
            } else AddError($_FILES['userfile']['error'][$i]); // Le fichier n'a pas été uploadé, on récupère l'erreur
            
            // Si le fichier a passé toutes les vérifications, on procède à l'upload, sinon on positionne la variable globale UploadError à 'true'
            if (!isset($ArrOfError[$_field]))
            {

            $UploadSuccess = true;

            WriteFile($_name, $_type, $_temp, $_size, $_ext, $_field);}
            else $UploadError = true;
        }
    }
    
    /**
     * Ecrit le fichier sur le serveur.
     *
     * @access private
     * @param string $name        nom du fichier sans son extension
     * @param string $type        entete du fichier
     * @param string $temp        chemin du fichier temporaire
     * @param string $size        taille du fichier en octets
     * @param string $temp        extension du fichier précédée d'un point
     * @param string $temp        extension du fichier précédée d'un point
     * @param string $num_fied    position du champ dans le formulaire à compter de 1
     * @return bool               true/false => succes/erreur
     */
    function WriteFile($name, $type, $temp, $size, $ext, $num_field) {
         global $new_filename,$Filename, $Prefixe,$Suffixe,  $WriteMode,$DirUpload,$Infos,$CopiExtension,$ImgMaxWidth,$ImgMaxHeight;
        $new_filename = NULL;
        //echo "On reçoit WriteFile($name, $type, $temp, $size, $ext, $num_field)<br>::::$Filename::::<br>";
        if (is_uploaded_file($temp)) {
            
            // Nettoyage du nom original du fichier
            if (Empty($Filename)) $new_filename = StripSlashes(CleanStr(substr($name, 0, strrpos($name, '.'))));
            else $new_filename = $Filename;
            
            // Ajout préfixes / suffixes + extension :
            $new_filename = $Prefixe . urldecode($new_filename) . $Suffixe . $ext;
            
            switch ($WriteMode) {
                // Si le fichier existe, on écrase
                case 0 : if (AlreadyExist($new_filename))
                {
                $uploaded = save_file($temp,$DirUpload,$new_filename);
                $Infos[$num_field]['avertissement']= "Le fichier existait déjà, il a été écrasé";
                }
                else 
                 {
                 $uploaded = save_file($temp,$DirUpload,$new_filename);
                 }
               
                         break;
                    
                // Si le fichier existe, on en fait une copie
                case 1 : if (AlreadyExist($new_filename))

                        
                         {
             $sub_filename = $new_filename;
             //préparation du préfixe
             if (!empty($CopiePrefixe))
             //prefixe fourni dans la config
             {
             $ajout='';
             while(AlreadyExist($new_filename))
                 {$new_filename = $CopiePrefixe . $new_filename;
                 $ajout.=$CopiePrefixe;
                 }
             
             }
             else {
             //préfixe créé par incrément
                         $i=1; while(AlreadyExist($new_filename))
                         {$new_filename = '['.$i.']' . $sub_filename;$i++;
             $ajout='['.($i-1).']';
             }
             }
              $uploaded = save_file($temp,$DirUpload,$new_filename);
               //on indique qu'un prefixe a été ajouté
              AddMessage(5,$ajout);}
                         else
                         {
               $uploaded = save_file($temp,$DirUpload,$new_filename);
           
               }
                          break;

      
                
                // Si le fichier existe, on ne fait rien
                case 2 :  if (AlreadyExist($new_filename))
                          {$uploaded = true;

               
                }
               
                          else $uploaded = save_file($temp,$DirUpload,$new_filename);
                          break;
            }
            
            // Informations pouvant être utiles au développeur (si le fichier a pu être copié)
            if ($uploaded != false) {
                $Infos[$num_field]['nom']          = $new_filename;
                $Infos[$num_field]['nom_originel'] = $name;
                $Infos[$num_field]['chemin']       = $DirUpload . $new_filename;
                $Infos[$num_field]['poids']        = number_format(filesize($DirUpload . $new_filename)/1024, 3, '.', '');
                $Infos[$num_field]['mime-type']    = $type;
                $Infos[$num_field]['extension']    = $ext;

            }

            return true;
        }// End is_uploaded_file

        return false;
    } // End function
    
   
    
    /**
     * Vérifie si le fichier passé en paramètre existe déjà dans le répertoire DirUpload
     * @access private
     * @return bool
     */
    function AlreadyExist($file) {
   
    global $DirUpload;
        if (!file_exists($DirUpload . $file)) return false;
        else return true;
    }

    /**
     * Vérifie la hauteur/largeur d'une image
     * @access private
     * @return bool
     */
    function CheckImg($_temp) {
        // Vérification de la largeur puis de la hauteur
        global $ImgMaxWidth,$ImgMaxHeight,$ImgMinWidth,$ImgMinHeight,$taille,$width,$height,$Resize;
        $height= false;
        $width = false;
        //echo "temp envoyé : $_temp<br>";
        if ($taille = @getimagesize($_temp) ) {
       
       if ($Resize)
        {

         if (!Empty($ImgMaxWidth)  && $taille[0] > $ImgMaxWidth)  $width= true;
        if (!Empty($ImgMaxHeight) && $taille[1] > $ImgMaxHeight) $height= true;
         }
         else {

            if (!Empty($ImgMaxWidth)  && $taille[0] > $ImgMaxWidth)  AddError(8);
            if (!Empty($ImgMaxHeight) && $taille[1] > $ImgMaxHeight) AddError(9);
        }
            if (!Empty($ImgMinWidth)  && $taille[0] < $ImgMinWidth) AddError(10);
            if (!Empty($ImgMinHeight) && $taille[1] < $ImgMinHeight) AddError(11);
        }
   
        return true;
    }
    
    /**
     * Vérifie l'extension des fichiers suivant celles précisées dans $Extension
     * @access private
     * @return bool
     */
    function CheckExtension($_ext) {

    global $Extension,$Extension_renamed,$_ext,$SuffExtension;
   
  
        $ArrOfExtension = explode(';', strtolower($Extension));
        $ArrOfExtension_renamed = explode(';', strtolower($Extension_renamed));
       
       
        if (!Empty($Extension) && !in_array($_ext, $ArrOfExtension)) {
    
           AddError(7);
           return false;
        }
           elseif (!Empty($Extension_renamed) && in_array($_ext, $ArrOfExtension_renamed)) {
           $_ext=$_ext.$SuffExtension;
   
            AddMessage(7);
            return true;
        }

        /*
    je ne sais plus à quoi sert cette vérif :-/
    if (!Empty($Extension) && in_array($_ext, $ArrOfExtension2)) {
            //echo "AddError(7) envoyé par checkextension()<br>";
           AddError(7);
            return false;
        }
    */

        return true;
    }

    /**
     * Vérifie l'entête des fichiers suivant ceux précisés dans $MimeType
     * @access private
     * @return bool
     */
    function CheckMimeType($_type) {
    global $MimeType;
         $ArrOfMimeType = explode(';', $MimeType);
 
        if (!Empty($MimeType) && !in_array($_type, $ArrOfMimeType)) {
         AddError(6);
            return false;
        }
        
        return true;
    }

    /**
     * Ajoute une erreur pour le fichier spécifié dans le tableau des erreur
     * @access private
     */
    function AddError($code_erreur) {
    global $msg,$_name,$Required,$_field,$ArrOfError,$MimeType,$Extension;
       
       // Le tableau des erreurs est de la forme :$arr[position_du_champ][code_erreur] = 'description';
         switch ($code_erreur) {
            case 1 : $msg = 'Le fichier à charger excède la directive upload_max_filesize (php.ini) ('. $_name .')<br>';
                     break;
            
            case 2 : $msg = 'Le fichier excède la directive MAX_FILE_SIZE qui a été spécifiée dans le formulaire ('. $_name .')<br>';
                     break;
            
            case 3 : $msg = 'Le fichier n\'a pu être chargé complètement ('. $_name .')<br>';
                     break;
            
            case 4 : $msg = 'Vous n\'avez pas indiqué de fichier à transmettre<br>';
                     break;
            
            case 5 : $msg = 'Fichier potentiellement dangereux ('. $_name .')<br>';
                     break;
            
            case 6 : $msg = 'Le type Mime de '.$_name .' n\'est pas conforme à la liste des entêtes autorisés ('. $MimeType .')<br>';
                     break;
            
            case 7 : $msg = 'L\'extension de '.$_name .' n\'est pas conforme à la liste des extensions autorisées ('. $Extension .')<br>';
                     break;
            
            case 8 : $msg = 'La largeur de l\'image dépasse celle autorisée ('. $_name .')<br>';
                     break;
            
            case 9 : $msg = 'La hauteur de l\'image dépasse celle autorisée ('. $_name .')<br>';
                     break;
            
            case 10 : $msg = 'La largeur de l\'image est inférieure à celle autorisée ('. $_name .')<br>';
                      break;
            
            case 11 : $msg = 'La hauteur de l\'image est inférieure à celle autorisée ('. $_name .')<br>';
                      break;
        }
        
        
        if ($Required && $code_erreur == 4) $ArrOfError[$_field][$code_erreur] = $msg;
        else if ($code_erreur != 4)                $ArrOfError[$_field][$code_erreur] = $msg;
    }
      /**
     * Ajoute un message pour le fichier spécifié dans le tableau des messages
     * @access private
     */
 
    function AddMessage($code_message,$ajout='') {
    global $msg,$_name,$new_filename,$_ext,$TrackMessage,$_field,$ArrOfMessage,$MimeType,$Extension;
       //j'ai ajouté cette fonction mais j'en utilise pas tous les paramètres
       //j'ai un peu la flemme de la nettoyer :p
       // Le tableau des erreurs est de la forme :$arr[position_du_champ][code_erreur] = 'description';
   
        switch ($code_message) {
            case 1 : $msg = 'Le fichier à charger excède la directive upload_max_filesize (php.ini) ('. $_name .')<br>';
                     break;
            
            case 2 : $msg = 'Le fichier excède la directive MAX_FILE_SIZE qui a été spécifiée dans le formulaire ('. $_name .')<br>';
                     break;
            
            case 3 : $msg = 'Le fichier n\'a pu être chargé complètement ('. $_name .')<br>';
                     break;
            
            case 4 : $msg = 'Le champ du formulaire était vide<br>';
                     break;
            //case 5 activé
            case 5 : $msg = 'Fichier préfixé avec '.$ajout.' car '. str_replace($ajout,"",$new_filename) .' existait déjà. <br>';
             
                     break;
            
            case 6 : $msg = 'Le fichier n\'est pas conforme à la liste des entêtes autorisés ('. $MimeType .')<br>';
                     break;
            //case 7 activé
            case 7 : $msg = 'L\'extension du fichier a été modifiée('. $_ext .')<br>';
                     break;
            
            case 8 : $msg = 'La largeur de l\'image dépasse celle autorisée ('. $_name .')<br>';
                     break;
            
            case 9 : $msg = 'La hauteur de l\'image dépasse celle autorisée ('. $_name .')<br>';
                     break;
            
            case 10 : $msg = 'La largeur de l\'image est inférieure à celle autorisée ('. $_name .')<br>';
                      break;
            
            case 11 : $msg = 'La hauteur de l\'image est inférieure à celle autorisée ('. $_name .')<br>';
                      break;

        }
        
       $ArrOfMessage[$_field][$code_message] = $msg;

    }
    
    /**
     * Vérifie les critères de la politique de sécurité
     * @access private
     * @return bool
     */
    function CheckSecurity($_type,$_ext) {

    global $SecurityMax;
         // Bloque tous les fichiers executables, et tous les fichiers php pouvant être interprétés mais dont l'entête ne peut les identifier comme étant dangereux
        if ($SecurityMax===true) {
            // Note : is_executable ne fonctionne pas => ?
            if (preg_match('/application/x-zip/', $_type) || preg_match("/.php|.inc|.php3/i", $_ext) ) {
                 AddError(5);

                return false;
            }
        }
          
        return true;
    }

    /**
     * Vérifie et formate le chemin de destination :
     *     - définit comme rep par défaut celui du script
     *     - teste l'existance du répertoire et son accès en écriture
     * @access private
     */
    function CheckDirUpload() {

    global $DirUpload;
     //echo "CheckDirUpload()<br>global DirUpload : $DirUpload<br>";
        // Si aucun répertoire n'a été précisé, on prend celui du script
        // j'ai enlevé cette possibilité
        //mais je laisse la ligne si vous voulez mettre un dossier particulier en cas de problème
        // un dossier 'upload erreurs' qui serait caché par exemple
        //if (Empty($DirUpload)) $DirUpload = dirname(__FILE__);

        $DirUpload = Win2UnixShlash(FormatDir($DirUpload));

        // Le répertoire existe?
        if (!is_dir($DirUpload)) Error('Le répertoire de destination spécifiée par la propriété DirUpload n\'existe pas.');
        // Droit en écriture ?
        if (!is_writeable($DirUpload)) Error('Le répertoire de destination spécifiée par la propriété DirUpload est inaccessible en écriture.');
    }

    /**
     * Formate le répertoire passé en paramètre
     *     - convertit un chemin relatif en chemin absolu
     *     - ajoute si besoin le dernier slash (ou antislash suivant le système)
     * @access private
     */
    function FormatDir($Dir) {

    //echo "FormatDir($Dir)<br>";
        // Convertit les chemins relatifs en chemins absolus
        //echo "CheckDirUpload<br>";
        if (function_exists('realpath')) {

            if (realpath($Dir)) $Dir = realpath($Dir);
        }
        
        // Position du dernier slash/antislash
        if ($Dir[strlen($Dir)-1] != DIRECTORY_SEPARATOR) $Dir .= DIRECTORY_SEPARATOR;
          
      return $Dir;
    }

    /**
     * Formate la chaine passée en paramètre en nom de fichier standard (pas de caractères spéciaux ni d'espaces)
     * @access private
     * @param  string $str   chaine à formater
     * @return string        chaine formatée
     */
    function CleanStr($str) {
        $return = '';
        
        for ($i=0; $i <= strlen($str)-1; $i++) {
            if (preg_match('/[a-z]/',$str{$i}))               $return .= $str{$i};
            elseif (preg_match('/[A-Z]/', $str{$i}))          $return .= $str{$i};
            elseif (preg_match('/[0-9]/', $str{$i}))          $return .= $str{$i};
            elseif (preg_match('/[àâäãáåÀÁÂÃÄÅ]/', $str{$i})) $return .= 'a';
            elseif (preg_match('/[æÆ]/', $str{$i}))           $return .= 'a';
            elseif (preg_match('/[çÇ]/', $str{$i}))           $return .= 'c';
            elseif (preg_match('/[éèêëÉÈÊËE]/', $str{$i}))    $return .= 'e';
            elseif (preg_match('/[îïìíÌÍÎÏ]/', $str{$i}))     $return .= 'i';
            elseif (preg_match('/[ôöðòóÒÓÔÕÖ]/', $str{$i}))   $return .= 'o';
            elseif (preg_match('/[ùúûüÙÚÛÜ]/', $str{$i}))     $return .= 'u';
            elseif (preg_match('/[ýÿÝŸ]/', $str{$i}))         $return .= 'y';              
			elseif (preg_match('/[ ]/', $str{$i}))            $return .= '_';
            elseif (preg_match('/[.]/', $str{$i}))            $return .= '_';
            elseif (preg_match('/[\']/', $str{$i}))           $return .= '_';
            elseif (preg_match('/["]/', $str{$i}))            $return .= '_';
            elseif (preg_match('/[\]/', $str{$i}))            $return .= '_';
            elseif (preg_match('/[/]/', $str{$i}))            $return .= '_';

			// suppression de tout ce qui n'est pas alphanumérique
			elseif (!preg_match('/[0-9]/', $str{$i}) || !preg_match('/[a-z]/',$str{$i}) || !preg_match('/[A-Z]/',$str{$i}) ) $return .= '_';
    
			elseif (preg_match('/[%]/', $str{$i}))              $return .= 'e';
			
            elseif (!preg_match('/[0-9]/', $str{$i}) || !preg_match('/[a-z]/',$str{$i}) || !preg_match('/[A-Z]/',$str{$i}) ) $return .= '_';
            else $return .= $str{$i};

        }
        
        return $return;
    }
    
    /**
     * Vérifie que la provenance du formulaire est bien celle précisée dans la propriétée CheckReferer.
     * @access private
     * @return bool
     */
    function VerifyReferer() {
    global $CheckReferer ;

        if (!Empty($CheckReferer)) {

        
            $headerref = $_SERVER['HTTP_REFERER'];
            
            // On enlève toutes les variables passées par url
            if (preg_match("/\?/",$headerref)){
                list($url, $getstuff) = split('\?', $headerref);
                $headerref = $url;
            }

            if ($headerref == $CheckReferer) return true;
            else 
        {
        $erreur='<br>Accès refusé, vous venez de :<br>'.$headerref.'<br> alors que le script n\'accepte que les données provenant de :<br>'.$CheckReferer.'.';
        Error($erreur);
         }
        }
    }

    /** Fonction désactivée
     * Initialise si possible le temps d'exécution max du script en fonction du nombre de fichiers et de la propriété max_file_size
     * @access private
     */
   /* function SetTimeLimit(){
    //echo "SetTimeLimit(".$_POST['MAX_FILE_SIZE'].")<br>";
        // Le temps calculé est théoriquement le plus rapide => * 2

        @set_time_limit(ceil(ceil($_POST['MAX_FILE_SIZE'] * 8) / ($Debit * 1000) * count($_FILES) * 2));

    }
     */
    
    
    /**
     * Conversion du poids maximum d'un fichier exprimée en Ko en octets
     * @access private
     */
    function SetMaxFilesize() {
    //echo "SetMaxFilesize()<br>";
    global $MaxFilesize;
        (is_numeric($MaxFilesize)) ? $MaxFilesize = $MaxFilesize * 1024 : Error('la propriété MaxFilesize doit être une valeur numérique');
    }

    /**
     * Crée les champs de type fichier suivant la propriété Fields dans un tableau $Field. Ajoute le contenu de FieldOptions aux champs.
     * @access private
     */
    function CreateFields() {
          global $MaxFilesize, $Fields, $FieldOptions, $Field;
              //echo "Createfields(globalMaxFilesize $MaxFilesize,Fields $Fields,FieldOptions $FieldOptions,Field $Field;)<br>";
    
        if (!is_int($Fields)) Error('la propriété Fields doit être un entier');
        
        for ($i=0; $i <= $Fields; $i++) {
            if ($i == 0)  $Field[] = '<input type="hidden" name="MAX_FILE_SIZE" value="'. $MaxFilesize .'">';
            else          $Field[] = '<input '. $FieldOptions .' type="file" name="userfile[]" >';
        }
    }

    /**
     * Vérifie la configuration de la classe.
     * @access private
     */
    function CheckConfig() {
     global $Extension,$MimeType,$Filename,$Debit,$Required,$SecurityMax,$WriteMode,$CheckReferer,$CopiePrefixe,$Extension_renamed,$SuffExtension,$Resize;
    
        if (!version_compare(phpversion(), '4.2.0')) Error('la version de php sur ce serveur est trop ancienne. Le module ne peut fonctionner qu\'avec une version égale ou supérieure à la version 4.1.0');
        if (!is_string($Extension)) Error('la propriété Extension est mal configurée.');
        if (!is_string($Extension_renamed)) Error('la propriété Extension_renamed est mal configurée.');
        if (!is_string($SuffExtension)) Error('la propriété SuffExtension est mal configurée.');
        if (!is_string($MimeType)) Error('la propriété MimeType est mal configurée.');
        if (!is_string($Filename)) Error('la propriété Filename est mal configurée.');
        if (!is_string($CopiePrefixe)) Error('la propriété CopiePrefixe est mal configurée.');
        //Fonction settimelimit désactivée
        //if (!is_numeric($Debit)) Error('la propriété Debit est mal configurée.');
        if (!is_bool($Required)) Error('la propriété Required est mal configurée.');
        if (!is_bool($Resize)) Error('la propriété Resize est mal configurée.');
        if (!is_bool($SecurityMax)) Error('la propriété SecurityMax est mal configurée.');
        if ($WriteMode != 0 && $WriteMode != 1 && $WriteMode != 2) Error('la propriété WriteMode est mal configurée.');
        if (!Empty($CheckReferer) && !@fopen($CheckReferer, 'r')) Error('la propriété CheckReferer est mal configurée.');
        CheckImgPossibility();
        CheckDirUpload();
    }

    /**
     * Vérifie les propriétés ImgMaxWidth/ImgMaxHeight
     * @access private
     */
    function CheckImgPossibility() {

    global $ImgMaxWidth,$ImgMaxHeight,$ImgMinWidth,$ImgMinHeight;

         if (!Empty($ImgMaxWidth)  && !is_numeric($ImgMaxWidth))   Error('la propriété ImgMaxWidth est mal configurée.');
        if (!Empty($ImgMaxHeight) && !is_numeric($ImgMaxHeight))  Error('la propriété ImgMaxHeight est mal configurée.');
        if (!Empty($ImgMinWidth)  && !is_numeric($ImgMinWidth))   Error('la propriété ImgMinWidth est mal configurée.');
        if (!Empty($ImgMinHeight) && !is_numeric($ImgMinHeight))  Error('la propriété ImgMinHeight est mal configurée.');
        if ($ImgMaxWidth < $ImgMinWidth)                          Error('la propriété ImgMaxWidth est inférieure à ImgMinWidth.');
        if ($ImgMaxHeight < $ImgMinHeight)                        Error('la propriété ImgMaxHeight est inférieure à ImgMinWidth.');

    }

    /**
     * Affiche les erreurs de configuration et stoppe tout traitement 
     * @access private
     */
    function Error($error_msg) {
          global $TrackError;
        if ($TrackError) {
            echo '<font color=red>Problème de configuration du script d\'upload: ' . $error_msg.'</font>';
            exit;
        }
    }
    
//thats's all folks ;-)
?>